unit MainFrms;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, FileUtil, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, LCLType, DBGrids, DbCtrls;

type

  { TMainFrm }

  TMainFrm = class(TForm)
    Bevel1: TBevel;
    btnApply: TButton;
    btnCreateDB: TButton;
    btnOpenDB: TButton;
    btnQuit: TButton;
    btnImgLoad: TButton;
    btnImgClear: TButton;
    dbeX: TDBEdit;
    dbeY: TDBEdit;
    dbeZ: TDBEdit;
    DBGrid1: TDBGrid;
    DBImage1: TDBImage;
    DBNavigator1: TDBNavigator;
    dscTiles: TDataSource;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    OpenDialog1: TOpenDialog;
    pgBDManager: TPageControl;
    SaveDialog1: TSaveDialog;
    tsContenu: TTabSheet;
    tsBdManager: TTabSheet;
    procedure btnApplyClick(Sender: TObject);
    procedure btnCreateDBClick(Sender: TObject);
    procedure btnImgClearClick(Sender: TObject);
    procedure btnImgLoadClick(Sender: TObject);
    procedure btnOpenDBClick(Sender: TObject);
    procedure btnQuitClick(Sender: TObject);
    procedure DBImage1DBImageRead(Sender: TObject; S: TStream;
      var GraphExt: string);
    procedure dscTilesStateChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  MainFrm: TMainFrm;

implementation

uses
  MainDms;

{$R *.lfm}

{ TMainFrm }

procedure TMainFrm.btnOpenDBClick(Sender: TObject);
begin
  OpenDialog1.DefaultExt := '.db';
  if OpenDialog1.Execute then
  begin
    MainDm.OpenDB(OpenDialog1.FileName);
  end;
  Label1.Caption := MainDm.DatabaseName;
  tsContenu.TabVisible := MainDm.Connected;
  if not MainDm.Connected then
    Application.MessageBox('Problème d''ouverture de la base ou contenu attendu non trouvé.', 'Erreur', IDOK);
end;

procedure TMainFrm.btnCreateDBClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    MainDm.CreateDB(SaveDialog1.FileName);
  end;
  Label1.Caption := MainDm.DatabaseName;
  tsContenu.TabVisible := MainDm.Connected;
  if not MainDm.Connected then
    Application.MessageBox('Problème de création de la base.', 'Erreur', IDOK);
end;

procedure TMainFrm.btnApplyClick(Sender: TObject);
begin
  // Applique les modifications apportées à la demande.
  MainDm.Apply(True);
end;

procedure TMainFrm.btnImgClearClick(Sender: TObject);
begin
  MainDm.ImgClear;
end;

procedure TMainFrm.btnImgLoadClick(Sender: TObject);
begin
  OpenDialog1.DefaultExt := '.jpg';
  if OpenDialog1.Execute then
    MainDm.ImgLoad(OpenDialog1.FileName);
end;

procedure TMainFrm.btnQuitClick(Sender: TObject);
begin
  Close;
End;

procedure TMainFrm.DBImage1DBImageRead(Sender: TObject; S: TStream;
  var GraphExt: string);
begin
  // Le format d'image doit être spécifié popur que le composant DBImage puisse
  // le restituer, dans un BLOB, on peut trouver n'importe quoi ...
  GraphExt := 'jpg';
end;

procedure TMainFrm.dscTilesStateChange(Sender: TObject);
begin
  MainDm.ApplyState(dscTiles.State);
  btnImgClear.Enabled := dscTiles.State in [dsEdit,dsInsert];
  btnImgload.Enabled := dscTiles.State in [dsEdit,dsInsert];
end;

procedure TMainFrm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  // Applique les modifications à la fermeture de la fiche
  MainDm.Apply(False);
end;

procedure TMainFrm.FormCreate(Sender: TObject);
begin
  Label1.Caption := MainDm.DatabaseName;
end;

procedure TMainFrm.FormShow(Sender: TObject);
begin
  pgBDManager.ActivePage := tsBdManager;
end;

end.

